Bug 565560 - [5.6 FEAT] KVM network performance: Defer skb allocation in virtio-net
[5.6 FEAT] KVM network performance: Defer skb allocation in virtio-net
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.6
other All
high Severity high
: beta
: 5.6
Assigned To: Steve Best
Red Hat Kernel QE team
: FutureFeature, OtherQA
Depends On:
Blocks: 557597 531800 Rhel5KvmTier1
  Show dependency treegraph
 
Reported: 2010-02-15 11:22 EST by IBM Bug Proxy
Modified: 2013-03-09 22:14 EST (History)
14 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-01-13 16:06:07 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
This is the proposed backport patch (21.03 KB, text/plain)
2010-04-08 16:40 EDT, IBM Bug Proxy
no flags Details
virtio skb optimization patchset (21.46 KB, text/plain)
2010-04-09 04:21 EDT, IBM Bug Proxy
no flags Details
Attached patch backported to RHEL5.6 kernel (20.17 KB, patch)
2010-09-23 16:45 EDT, Anthony Liguori
no flags Details | Diff
Attached patch backported to RHEL5.6 kernel (v2) (20.17 KB, patch)
2010-09-23 17:19 EDT, Anthony Liguori
no flags Details | Diff
Working backport to RHEL5.6 kernel (20.84 KB, patch)
2010-09-24 18:42 EDT, Anthony Liguori
no flags Details | Diff


External Trackers
Tracker ID Priority Status Summary Last Updated
IBM Linux Technology Center 59994 None None None Never

  None (edit)
Description IBM Bug Proxy 2010-02-15 11:22:14 EST
1. Feature Overview:
Feature Id: [59994]
a. Name of Feature: [5.6 FEAT] KVM network performance: Defer skb allocation in virtio-net
b. Feature Description
vhost-net patchset : add  tap and raw socket backend support to host kernel to improve network latency
udp fragmentation offload: improve throughput of guest-host/guest-guest by enabling UFO to
send/receive large UDP packets 
virtio-net performance enhancement : avoid unnecessary skb allocs/frees for large packet in guest
receive path by deferring skb allocations
IGMP Snooping: to briding code to improve multicast performnace when using a
bridge to connect multiple guests.

2. Feature Details:
Sponsor: LTC Networking
Architectures:
  x86x86_64

Arch Specificity: both
Affects Kernel Modules: Yes
Delivery Mechanism: Direct from Community
Category: kernel
Request Type: Package - Version Update
d. Upstream Acceptance: Accepted
Sponsor Priority P2
f. Severity: high
IBM Confidential: No
Code Contribution: IBM code
g. Component Version Target:
---

3. Business Case
The network performance for  communication across VM to VM and host-VM  must be
close to native perf. to migrate applications to KVM, be competitive with
industry virtualization solutions, and support efficient workloads even as a
large number of VMs supported per host.

4. Primary contact at Red Hat:
John Jarvis
jjarvis@redhat.com

5. Primary contacts at Partner:
Project Management Contact:
Stephanie A. Glass, sglass@us.ibm.com

Technical contact(s):
Sridhar Samudrala, samudrala@us.ibm.com
Comment 3 Anthony Liguori 2010-03-30 10:44:51 EDT
Sridhar,

Please attach patches backported and tested against the RHEL5.5 kernel.  Thanks!
Comment 4 IBM Bug Proxy 2010-04-08 16:40:57 EDT
Created attachment 405403 [details]
This is the proposed backport patch


------- Comment on attachment From xma@us.ibm.com 2010-04-08 16:37 EDT-------


Tests are still going on, with this patch the initial test local guest to host netperf result is from 6730.45 Gb/s to 
8019.53 Gb/s same cpu utilization rate.
Comment 5 IBM Bug Proxy 2010-04-09 03:52:09 EDT
------- Comment From xma@us.ibm.com 2010-04-09 03:44 EDT-------
The patch has been tested. However, this patch seems triggered an existing bug in virtio_ring.c when removing virtio_net module manually. I am not going to include the fix in this patch. I will file a bug separately.
Comment 6 IBM Bug Proxy 2010-04-09 04:21:01 EDT
Created attachment 405486 [details]
virtio skb optimization patchset


------- Comment on attachment From xma@us.ibm.com 2010-04-09 04:13 EDT-------


This patch has been tested. It's ready for pick up.
Comment 7 IBM Bug Proxy 2010-04-09 04:31:07 EDT
------- Comment From xma@us.ibm.com 2010-04-09 04:21 EDT-------
The update patch has all fixes so we don't need to submit another fix.
Comment 8 John Jarvis 2010-09-22 10:58:22 EDT
IBM is signed up to test and provide feedback.
Comment 9 Anthony Liguori 2010-09-23 16:45:00 EDT
Created attachment 449303 [details]
Attached patch backported to RHEL5.6 kernel
Comment 10 Anthony Liguori 2010-09-23 17:19:03 EDT
Created attachment 449308 [details]
Attached patch backported to RHEL5.6 kernel (v2)
Comment 11 Anthony Liguori 2010-09-24 18:42:00 EDT
Created attachment 449534 [details]
Working backport to RHEL5.6 kernel

Attached patch works against the latest RHEL5.6 kernel tested under heavy network load in a RHEL5.5 KVM.
Comment 12 Steve Best 2010-09-27 05:35:09 EDT
Anthony posted this to rh-kernel mailing list
http://post-office.corp.redhat.com/archives/rhkernel-list/2010-September/msg01191.html
Comment 13 John Jarvis 2010-09-30 16:37:45 EDT
This enhancement request was evaluated by the full Red Hat Enterprise Linux 
team for inclusion in a Red Hat Enterprise Linux minor release.   As a 
result of this evaluation, Red Hat has tentatively approved inclusion of 
this feature in the next Red Hat Enterprise Linux Update minor release.   
While it is a goal to include this enhancement in the next minor release 
of Red Hat Enterprise Linux, the enhancement is not yet committed for 
inclusion in the next minor release pending the next phase of actual 
code integration and successful Red Hat and partner testing.
Comment 15 Jarod Wilson 2010-10-14 10:01:57 EDT
in kernel-2.6.18-227.el5
You can download this test kernel (or newer) from http://people.redhat.com/jwilson/el5

Detailed testing feedback is always welcomed.
Comment 17 Chris Ward 2010-11-09 08:38:01 EST
~~ Attention Customers and Partners - RHEL 5.6 Public Beta is now available on RHN ~~

A fix for this 'OtherQA' BZ should be present and testable in the release. 

If this Bugzilla is verified as resolved, please update the Verified field above with an appropriate value and include a summary of the testing executed and the results obtained.

If you encounter any issues or have questions while testing, please describe them and set this bug into NEED_INFO. 

If you encounter new defects or have additional patches to request for inclusion, promptly escalate the new issues through your support representative.

Finally, future Beta kernels can be found here:
 http://people.redhat.com/jwilson/el5/

Note: Bugs with the 'OtherQA' keyword require Third-Party testing to confirm the request has been properly addressed. See: https://bugzilla.redhat.com/describekeywords.cgi#OtherQA ).
Comment 18 John Jarvis 2010-11-18 15:53:30 EST
This enhancement request was evaluated by the full Red Hat Enterprise Linux 
team for inclusion in a Red Hat Enterprise Linux minor release.   As a 
result of this evaluation, Red Hat has tentatively approved inclusion of 
this feature in the next Red Hat Enterprise Linux Update minor release.   
While it is a goal to include this enhancement in the next minor release 
of Red Hat Enterprise Linux, the enhancement is not yet committed for 
inclusion in the next minor release pending the next phase of actual 
code integration and successful Red Hat and partner testing.
Comment 19 Chris Ward 2010-12-02 10:30:25 EST
Reminder! There should be a fix present for this BZ in snapshot 3 -- unless otherwise noted in a previous comment.

Please test and update this BZ with test results as soon as possible.
Comment 20 IBM Bug Proxy 2010-12-02 12:21:38 EST
------- Comment From xma@us.ibm.com 2010-12-02 12:15 EDT-------
This feature has been passed netperf test for snapshot 2. What else should we do for snapshot 3?
Comment 21 Chris Ward 2010-12-03 05:03:26 EST
@IBM, nothing. Thanks for the information. I'll mark this bug as verified by IBM. Thanks!
Comment 23 errata-xmlrpc 2011-01-13 16:06:07 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2011-0017.html

Note You need to log in before you can comment on or make changes to this bug.